package com.fp.persistence.parmas.soli;

import javax.persistence.EmbeddedId;
import javax.persistence.Entity;
import javax.persistence.Column;
import javax.persistence.EntityManager;

import java.io.Serializable;

import javax.persistence.Table;

import com.fp.dto.hb.HibernateBean;
import com.fp.dto.hb.Log;

import javax.persistence.Version;

import java.lang.reflect.Field;

import javax.persistence.Transient;

/**Clase que implementa la entidad de Hibernate que hace referencia a la tabla TARMAGENCIAARMA*/
@Entity(name="TarmAgenciaArma")
@Table(name="TARMAGENCIAARMA")
public class TarmAgenciaArma extends com.fp.dto.AbstractDataTransport implements Serializable,HibernateBean,Cloneable, Log {
/**
* HashCode asociado con la Instancia
*/
@Transient
private int hashValue = 0;
/**
* Version de la Clase
*/
private static final long serialVersionUID = 1L;
/**
* Clave primaria de la Entidad TarmAgenciaArma
*/
@EmbeddedId
private TarmAgenciaArmaKey pk;
/**Contructor por defecto*/
public TarmAgenciaArma(){
}
/**Contructor de TarmAgenciaArma
@param pPk Clave Primaria del entity
*/
public TarmAgenciaArma(TarmAgenciaArmaKey pPk){
 this();
 pk=pPk;
}
/**
* Metodo que entrega datos de la tabla dada la clave primaria.
* @param pEntityManager referencia de la session a obtener datos del bean.
* @param pKey Caleve primaria del bean.
* @return TarmAgenciaArma
*/
public static TarmAgenciaArma find(EntityManager pEntityManager,TarmAgenciaArmaKey pKey) throws Exception{
    TarmAgenciaArma obj = pEntityManager.find(TarmAgenciaArma.class,pKey);
    return obj;
}
/**Entrega la Clave primaria de TarmAgenciaArma
@return El objeto que referencia a la Clave primaria de TarmAgenciaArma
*/
public TarmAgenciaArmaKey getPk(){
  return pk;
}
/**Fija un nuevo valor a la Clave primaria de TarmAgenciaArma
@param pPk El objeto que referencia a la nueva Clave primaria de TarmAgenciaArma
*/
public void setPk(TarmAgenciaArmaKey pPk){
  pk=pPk;
}
public boolean equals(Object rhs){
    if (rhs == null)return false;
    if (! (rhs instanceof TarmAgenciaArma))return false;
    TarmAgenciaArma that = (TarmAgenciaArma) rhs;
    if (this.getPk() == null || that.getPk() == null)
        return false;
    return (this.getPk().equals(that.getPk()));
}
/**Implementacion del metodo hashCode de la la entidad TarmAgenciaArma
@return el hashCode la instancia
*/
public int hashCode()    {
    if (this.hashValue == 0){
        int result = 17;
        if (this.getPk() == null){
            result = super.hashCode();
        }else{
            result = this.getPk().hashCode();
        }
        this.hashValue = result;
    }
    return this.hashValue;
}
/**Implementacion toString
*/
public String toString() {
	Field[]fs=this.getClass().getDeclaredFields();
	String data="";
	for(Field f:fs){
	 try{	
	 String name=f.getName();
   if(f.getType().getName().compareTo("java.util.Set")==0)continue;
	 if(name.compareTo("hashValue")==0||name.compareTo("serialVersionUID")==0)continue;
		data+=name+"="+f.get(this)+";";
	 }catch(Exception e){
		 continue;
	 }
		}
		if(data.compareTo("")==0){
		data=super.toString();
		}
	return data;
	}
/**Implementacion de la creacion de un bean en blanco TarmAgenciaArma
*/
public Object createInstance(){
 TarmAgenciaArma instance=new TarmAgenciaArma();	
 instance.setPk(new TarmAgenciaArmaKey());
 return instance;
}
/**Clona la entidad TarmAgenciaArma
@see com.fp.dto.hb.HibernateBean#cloneMe()
*/
public Object cloneMe() throws CloneNotSupportedException{
  TarmAgenciaArma p=(TarmAgenciaArma)this.clone();
  p.setPk((TarmAgenciaArmaKey)this.pk.cloneMe());
  return p;
}
}
